diff --git a/src/lua.c b/src/lua.c
index ca5b298..edfb479 100644
--- a/src/lua.c
+++ b/src/lua.c
@@ -85,6 +85,13 @@
 #define lua_saveline(L,line)	((void)L, add_history(line))
 #define lua_freeline(L,b)	((void)L, free(b))
 
+#elif defined(LUA_USE_LINENOISE)/* }{ */
+
+#include "linenoise.h"
+#define lua_readline(L,b,p)	((void)L, ((b)=linenoise(p)) != NULL)
+#define lua_saveline(L,line)	((void)L, linenoiseHistoryAdd(line))
+#define lua_freeline(L,b)	((void)L, free(b))
+
 #else				/* }{ */
 
 #define lua_readline(L,b,p) \
